diff -ur jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageAffine_BL_U16.c jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageAffine_BL_U16.c
--- jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageAffine_BL_U16.c	   :: 
+++ jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageAffine_BL_U16.c	   :: 
@@ -77,9 +77,226 @@
 #define FUN_NAME(CHAN) mlib_ImageAffine_u16_##CHAN##_bl
 
 /***************************************************************/
-/* for x86, using integer multiplies is faster */
+#ifdef __sparc /* for SPARC, using floating-point multiplies is faster */
 
 /***************************************************************/
+#define GET_POINTERS(ind)                                       \
+  fdx = (FTYPE)(X & MLIB_MASK) * scale;                         \
+  fdy = (FTYPE)(Y & MLIB_MASK) * scale;                         \
+  ySrc = MLIB_POINTER_SHIFT(Y);  Y += dY;                       \
+  xSrc = X >> MLIB_SHIFT;  X += dX;                             \
+  srcPixelPtr = MLIB_POINTER_GET(lineAddr, ySrc) + ind * xSrc;  \
+  srcPixelPtr2 = (DTYPE *)((mlib_u8 *)srcPixelPtr + srcYStride)
+
+/***************************************************************/
+#define COUNT(ind)                                              \
+  pix0_##ind = a00_##ind + fdy * (a10_##ind - a00_##ind);       \
+  pix1_##ind = a01_##ind + fdy * (a11_##ind - a01_##ind);       \
+  res##ind = ROUND(pix0_##ind + fdx * (pix1_##ind - pix0_##ind))
+
+/***************************************************************/
+#define LOAD(ind, ind1, ind2)                                   \
+  a00_##ind = I2F(srcPixelPtr[ind1]);                           \
+  a01_##ind = I2F(srcPixelPtr[ind2]);                           \
+  a10_##ind = I2F(srcPixelPtr2[ind1]);                          \
+  a11_##ind = I2F(srcPixelPtr2[ind2])
+
+/***************************************************************/
+mlib_status FUN_NAME(1ch)(mlib_affine_param *param)
+{
+  DECLAREVAR_BL();
+  DTYPE *dstLineEnd;
+  DTYPE *srcPixelPtr2;
+  FTYPE scale = (FTYPE) 1.0 / MLIB_PREC;
+
+  for (j = yStart; j <= yFinish; j++) {
+    FTYPE fdx, fdy;
+    TTYPE a00_0, a01_0, a10_0, a11_0;
+    FTYPE pix0_0, pix1_0, res0;
+
+    CLIP(1);
+    dstLineEnd = (DTYPE *) dstData + xRight;
+
+    GET_POINTERS(1);
+    LOAD(0, 0, 1);
+
+#ifdef __SUNPRO_C
+#pragma pipeloop(0)
+#endif /* __SUNPRO_C */
+    for (; dstPixelPtr < dstLineEnd; dstPixelPtr++) {
+      COUNT(0);
+      GET_POINTERS(1);
+      LOAD(0, 0, 1);
+      dstPixelPtr[0] = (DTYPE) res0;
+    }
+
+    COUNT(0);
+    dstPixelPtr[0] = (DTYPE) res0;
+  }
+
+  return MLIB_SUCCESS;
+}
+
+/***************************************************************/
+mlib_status FUN_NAME(2ch)(mlib_affine_param *param)
+{
+  DECLAREVAR_BL();
+  DTYPE *dstLineEnd;
+  DTYPE *srcPixelPtr2;
+  FTYPE scale = (FTYPE) 1.0 / MLIB_PREC;
+
+  for (j = yStart; j <= yFinish; j++) {
+    FTYPE fdx, fdy;
+    TTYPE a00_0, a01_0, a10_0, a11_0;
+    TTYPE a00_1, a01_1, a10_1, a11_1;
+    FTYPE pix0_0, pix1_0, res0;
+    FTYPE pix0_1, pix1_1, res1;
+
+    CLIP(2);
+    dstLineEnd = (DTYPE *) dstData + 2 * xRight;
+
+    GET_POINTERS(2);
+    LOAD(0, 0, 2);
+    LOAD(1, 1, 3);
+
+#ifdef __SUNPRO_C
+#pragma pipeloop(0)
+#endif /* __SUNPRO_C */
+    for (; dstPixelPtr < dstLineEnd; dstPixelPtr += 2) {
+      COUNT(0);
+      COUNT(1);
+      GET_POINTERS(2);
+      LOAD(0, 0, 2);
+      LOAD(1, 1, 3);
+      dstPixelPtr[0] = (DTYPE) res0;
+      dstPixelPtr[1] = (DTYPE) res1;
+    }
+
+    COUNT(0);
+    COUNT(1);
+    dstPixelPtr[0] = (DTYPE) res0;
+    dstPixelPtr[1] = (DTYPE) res1;
+  }
+
+  return MLIB_SUCCESS;
+}
+
+/***************************************************************/
+mlib_status FUN_NAME(3ch)(mlib_affine_param *param)
+{
+  DECLAREVAR_BL();
+  DTYPE *dstLineEnd;
+  DTYPE *srcPixelPtr2;
+  FTYPE scale = (FTYPE) 1.0 / MLIB_PREC;
+
+  for (j = yStart; j <= yFinish; j++) {
+    FTYPE fdx, fdy;
+    FTYPE a00_0, a01_0, a10_0, a11_0;
+    FTYPE a00_1, a01_1, a10_1, a11_1;
+    FTYPE a00_2, a01_2, a10_2, a11_2;
+    FTYPE pix0_0, pix1_0, res0;
+    FTYPE pix0_1, pix1_1, res1;
+    FTYPE pix0_2, pix1_2, res2;
+
+    CLIP(3);
+    dstLineEnd = (DTYPE *) dstData + 3 * xRight;
+
+    GET_POINTERS(3);
+    LOAD(0, 0, 3);
+    LOAD(1, 1, 4);
+    LOAD(2, 2, 5);
+
+#ifdef __SUNPRO_C
+#pragma pipeloop(0)
+#endif /* __SUNPRO_C */
+    for (; dstPixelPtr < dstLineEnd; dstPixelPtr += 3) {
+      COUNT(0);
+      COUNT(1);
+      COUNT(2);
+      GET_POINTERS(3);
+      LOAD(0, 0, 3);
+      LOAD(1, 1, 4);
+      LOAD(2, 2, 5);
+      dstPixelPtr[0] = (DTYPE) res0;
+      dstPixelPtr[1] = (DTYPE) res1;
+      dstPixelPtr[2] = (DTYPE) res2;
+    }
+
+    COUNT(0);
+    COUNT(1);
+    COUNT(2);
+    dstPixelPtr[0] = (DTYPE) res0;
+    dstPixelPtr[1] = (DTYPE) res1;
+    dstPixelPtr[2] = (DTYPE) res2;
+  }
+
+  return MLIB_SUCCESS;
+}
+
+/***************************************************************/
+mlib_status FUN_NAME(4ch)(mlib_affine_param *param)
+{
+  DECLAREVAR_BL();
+  DTYPE *dstLineEnd;
+  DTYPE *srcPixelPtr2;
+  FTYPE scale = (FTYPE) 1.0 / MLIB_PREC;
+
+  for (j = yStart; j <= yFinish; j++) {
+    FTYPE fdx, fdy;
+    TTYPE a00_0, a01_0, a10_0, a11_0;
+    TTYPE a00_1, a01_1, a10_1, a11_1;
+    TTYPE a00_2, a01_2, a10_2, a11_2;
+    TTYPE a00_3, a01_3, a10_3, a11_3;
+    FTYPE pix0_0, pix1_0, res0;
+    FTYPE pix0_1, pix1_1, res1;
+    FTYPE pix0_2, pix1_2, res2;
+    FTYPE pix0_3, pix1_3, res3;
+
+    CLIP(4);
+    dstLineEnd = (DTYPE *) dstData + 4 * xRight;
+
+    GET_POINTERS(4);
+    LOAD(0, 0, 4);
+    LOAD(1, 1, 5);
+    LOAD(2, 2, 6);
+    LOAD(3, 3, 7);
+
+#ifdef __SUNPRO_C
+#pragma pipeloop(0)
+#endif /* __SUNPRO_C */
+    for (; dstPixelPtr < dstLineEnd; dstPixelPtr += 4) {
+      COUNT(0);
+      COUNT(1);
+      COUNT(2);
+      COUNT(3);
+      GET_POINTERS(4);
+      LOAD(0, 0, 4);
+      LOAD(1, 1, 5);
+      LOAD(2, 2, 6);
+      LOAD(3, 3, 7);
+      dstPixelPtr[0] = (DTYPE) res0;
+      dstPixelPtr[1] = (DTYPE) res1;
+      dstPixelPtr[2] = (DTYPE) res2;
+      dstPixelPtr[3] = (DTYPE) res3;
+    }
+
+    COUNT(0);
+    COUNT(1);
+    COUNT(2);
+    COUNT(3);
+    dstPixelPtr[0] = (DTYPE) res0;
+    dstPixelPtr[1] = (DTYPE) res1;
+    dstPixelPtr[2] = (DTYPE) res2;
+    dstPixelPtr[3] = (DTYPE) res3;
+  }
+
+  return MLIB_SUCCESS;
+}
+
+/***************************************************************/
+#else       /* for x86, using integer multiplies is faster */
+
+/***************************************************************/
 /* for SHORT/USHORT decrease MLIB_SHIFT due to overflow in multiplies like fdy * (a10 - a00) */
 #undef  MLIB_SHIFT
 #define MLIB_SHIFT  15
@@ -346,4 +575,6 @@
   return MLIB_SUCCESS;
 }
 
+#endif /* #ifdef __sparc */
+
 /***************************************************************/
diff -ur jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv.h jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv.h
--- jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv.h	   :: 
+++ jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv.h	   :: 
@@ -61,7 +61,7 @@
                                  mlib_s32         scale,
                                  mlib_s32         cmask);
 
-/* for x86, using integer multiplies is faster */
+#if ! defined ( __sparc ) /* for x86, using integer multiplies is faster */
 
 mlib_status mlib_i_convMxNnw_s16(mlib_image       *dst,
                                  const mlib_image *src,
@@ -129,6 +129,8 @@
                                   mlib_s32         scale,
                                   mlib_s32         cmask);
 
+#endif /* ! defined ( __sparc ) ( for x86, using integer multiplies is faster ) */
+
 #ifdef __cplusplus
 }
 #endif /* __cplusplus */
diff -ur jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConvVersion.c jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConvVersion.c
--- jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConvVersion.c	   :: 
+++ jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConvVersion.c	   :: 
@@ -51,6 +51,9 @@
                                mlib_s32 scale,
                                mlib_type type)
 {
+#ifdef __sparc
+  return 0;
+#else
   mlib_d64 dscale = 1.0 / (1 << scale); /* 16 < scale <= 31 */
 
   if (type == MLIB_BYTE) {
@@ -66,6 +69,7 @@
   }
   else
     return 0;
+#endif /* __sparc */
 }
 
 /***************************************************************/
diff -ur jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv_f.c jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv_f.c
--- jdk-jdk-15-26/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv_f.c	   :: 
+++ jdk-jdk-15-25/src/java.desktop/share/native/libmlib_image/mlib_c_ImageConv_f.c	   :: 
@@ -66,19 +66,29 @@
 /***************************************************************/
 mlib_status mlib_convMxNnw_u8(MLIB_PARAMS_CONV_MN_NW)
 {
+#ifdef __sparc
+  return mlib_c_convMxNnw_u8(MLIB_CALL_PARAMS_CONV_MN_NW);
+#else
+
   if (mlib_ImageConvVersion(m, n, scale, MLIB_BYTE) == 0)
     return mlib_c_convMxNnw_u8(MLIB_CALL_PARAMS_CONV_MN_NW);
   else
     return mlib_i_convMxNnw_u8(MLIB_CALL_PARAMS_CONV_MN_NW);
+#endif /* __sparc */
 }
 
 /***************************************************************/
 mlib_status mlib_convMxNext_u8(MLIB_PARAMS_CONV_MN_EXT)
 {
+#ifdef __sparc
+  return mlib_c_convMxNext_u8(MLIB_CALL_PARAMS_CONV_MN_EXT);
+#else
+
   if (mlib_ImageConvVersion(m, n, scale, MLIB_BYTE) == 0)
     return mlib_c_convMxNext_u8(MLIB_CALL_PARAMS_CONV_MN_EXT);
   else
     return mlib_i_convMxNext_u8(MLIB_CALL_PARAMS_CONV_MN_EXT);
+#endif /* __sparc */
 }
 
 /***************************************************************/
diff -ur jdk-jdk-15-26/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/utilities/PlatformInfo.java jdk-jdk-15-25/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/utilities/PlatformInfo.java
--- jdk-jdk-15-26/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/utilities/PlatformInfo.java	   :: 
+++ jdk-jdk-15-25/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/utilities/PlatformInfo.java	   :: 
@@ -54,7 +54,7 @@
 
   public static boolean knownCPU(String cpu) {
     final String[] KNOWN =
-        new String[] {"i386", "x86", "x86_64", "amd64", "ppc64", "ppc64le", "aarch64", "riscv64"};
+        new String[] {"i386", "x86", "x86_64", "amd64", "sparc", "sparcv9", "ppc64", "ppc64le", "aarch64", "riscv64"};
 
     for(String s : KNOWN) {
       if(s.equals(cpu))
@@ -81,6 +81,9 @@
     if (cpu.equals("i386"))
       return "x86";
 
+    if (cpu.equals("sparcv9"))
+      return "sparc";
+
     if (cpu.equals("x86_64"))
       return "amd64";
 
diff -ur jdk-jdk-15-26/src/jdk.internal.vm.ci/share/classes/module-info.java jdk-jdk-15-25/src/jdk.internal.vm.ci/share/classes/module-info.java
--- jdk-jdk-15-26/src/jdk.internal.vm.ci/share/classes/module-info.java	   :: 
+++ jdk-jdk-15-25/src/jdk.internal.vm.ci/share/classes/module-info.java	   :: 
@@ -39,5 +39,6 @@
 
     provides jdk.vm.ci.hotspot.HotSpotJVMCIBackendFactory with
         jdk.vm.ci.hotspot.aarch64.AArch64HotSpotJVMCIBackendFactory,
-        jdk.vm.ci.hotspot.amd64.AMD64HotSpotJVMCIBackendFactory;
+        jdk.vm.ci.hotspot.amd64.AMD64HotSpotJVMCIBackendFactory,
+        jdk.vm.ci.hotspot.sparc.SPARCHotSpotJVMCIBackendFactory;
 }
diff -ur jdk-jdk-15-26/src/jdk.internal.vm.ci/share/classes/jdk/vm/ci/hotspot/HotSpotVMConfig.java jdk-jdk-15-25/src/jdk.internal.vm.ci/share/classes/jdk/vm/ci/hotspot/HotSpotVMConfig.java
--- jdk-jdk-15-26/src/jdk.internal.vm.ci/share/classes/jdk/vm/ci/hotspot/HotSpotVMConfig.java	   :: 
+++ jdk-jdk-15-25/src/jdk.internal.vm.ci/share/classes/jdk/vm/ci/hotspot/HotSpotVMConfig.java	   :: 
@@ -62,6 +62,8 @@
             case "x86_64":
                 return "amd64";
 
+            case "sparcv9":
+                return "sparc";
             default:
                 return arch;
         }
diff -ur jdk-jdk-15-26/src/jdk.sctp/unix/native/libsctp/SctpChannelImpl.c jdk-jdk-15-25/src/jdk.sctp/unix/native/libsctp/SctpChannelImpl.c
--- jdk-jdk-15-26/src/jdk.sctp/unix/native/libsctp/SctpChannelImpl.c	   :: 
+++ jdk-jdk-15-25/src/jdk.sctp/unix/native/libsctp/SctpChannelImpl.c	   :: 
@@ -485,6 +485,20 @@
                 bufp = newBuf;
                 rv += rvSAVE;
             }
+#ifdef __sparc
+              else if ((intptr_t)addr & 0x3) {
+                /* the given buffer is not 4 byte aligned */
+                char* newBuf;
+                if ((newBuf = malloc(SCTP_NOTIFICATION_SIZE)) == NULL) {
+                    JNU_ThrowOutOfMemoryError(env, "Out of native heap space.");
+                    return -1;
+                }
+                allocated = JNI_TRUE;
+
+                memcpy(newBuf, addr, rv);
+                bufp = newBuf;
+            }
+#endif
             snp = (union sctp_notification *) bufp;
             if (handleNotification(env, fd, resultContainerObj, snp, rv,
                                    (msg->msg_flags & MSG_EOR),
diff -ur jdk-jdk-15-26/src/utils/hsdis/hsdis.c jdk-jdk-15-25/src/utils/hsdis/hsdis.c
--- jdk-jdk-15-26/src/utils/hsdis/hsdis.c	   :: 
+++ jdk-jdk-15-25/src/utils/hsdis/hsdis.c	   :: 
@@ -484,6 +484,12 @@
 #ifdef LIBARCH_amd64
   res = "i386:x86-64";
 #endif
+#ifdef LIBARCH_sparc
+  res = "sparc:v8plusb";
+#endif
+#ifdef LIBARCH_sparcv9
+  res = "sparc:v9b";
+#endif
 #if  defined(LIBARCH_ppc64) || defined(LIBARCH_ppc64le)
   res = "powerpc:common64";
 #endif
--- old/make/test/JtregNativeHotspot.gmk	2020-05-20 17:59:33.301561154 -0700
+++ new/make/test/JtregNativeHotspot.gmk	2020-05-20 17:59:32.909553627 -0700
@@ -852,6 +852,10 @@
 ################################################################################
 
 # Platform specific setup
+ifeq ($(call And, $(call isTargetOs, solaris) $(call isTargetCpuArch, sparc)), false)
+  BUILD_HOTSPOT_JTREG_EXCLUDE += liboverflow.c exeThreadSignalMask.c
+endif
+
 ifeq ($(call isTargetOs, linux), true)
     BUILD_HOTSPOT_JTREG_LIBRARIES_LDFLAGS_libtest-rw := -z noexecstack
     BUILD_HOTSPOT_JTREG_LIBRARIES_LDFLAGS_libtest-rwx := -z execstack
--- old/src/java.desktop/share/classes/sun/awt/image/ImagingLib.java	2020-05-20 18:01:43.720065285 -0700
+++ new/src/java.desktop/share/classes/sun/awt/image/ImagingLib.java	2020-05-20 18:01:43.384058832 -0700
@@ -95,12 +95,15 @@
                 public Boolean run() {
                     String arch = System.getProperty("os.arch");
 
+                    if (arch == null || !arch.startsWith("sparc")) {
+                        try {
+                            System.loadLibrary("mlib_image");
+                        } catch (UnsatisfiedLinkError e) {
+                            return Boolean.FALSE;
+                        }
+
-                    try {
-                        System.loadLibrary("mlib_image");
-                    } catch (UnsatisfiedLinkError e) {
-                        return Boolean.FALSE;
                     }
+                    boolean success =  init();
-                    boolean success = init();
                     return Boolean.valueOf(success);
                 }
             };
